#!/bin/bash
##########################################
# File Name:check_port.sh
# Version:V1.0
# Author:zhangpeng
# 0rganization:linuxjk.cn
# Desc:案例33：检查指定地址的端口是否可以访问
#use color funcs
source /funcs/func_diy.sh
###########################################
#1.vars
ip=$1
port=$2
#2.检查参数数量是否为2（ip＋端口）
#这一步涉及到传参所以需要在主函数里加上$@
num_part(){
if [ $# -ne 2 ];then
redecho "Help: sh $0 IP PORT  "
exit 1
fi
}

#检查nc/telnet命令是否存在，不存在则安装
use_yum(){
if ! which nc &>/dev/null ;then
yum install -y nc &>/dev/null
fi
#yum install -y telnet &>/dev/null
}

#使用ping命令检查到目标ip之间是否通路
use_ping(){
if ! ping -c1 $ip &>/dev/null ;then
	redecho "this ip connect failed!"
	exit 2
fi
}
#检查端口格式（必须为数字）
check_port(){
if [[ ! $port =~ ^[0-9]+$ ]];then
	redecho "port $port is not exist! pls input number(1-65535) "
	exit 3
fi
}
#3.执行nc命令检查端口连接
use_nc(){
if nc -z ${ip} ${port} ;then
	greenecho "success! $ip $port is open"
else
	redecho "failed! $ip $port is closed "
fi
}


function main(){
num_part "$@"
use_yum
use_ping
check_port
use_nc
}
main "$@"
